// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'HidControllerClass.pas' rev: 6.00

#ifndef HidControllerClassHPP
#define HidControllerClassHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Hid.hpp>	// Pascal unit
#include <SetupApi.hpp>	// Pascal unit
#include <DBT.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Hidcontrollerclass
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TJvHidDevice;
typedef bool __fastcall (__closure *TJvHidEnumerateEvent)(const TJvHidDevice* HidDev, const int Idx);

typedef void __fastcall (__closure *TJvHidUnplugEvent)(const TJvHidDevice* HidDev);

#pragma option push -b-
enum TJvOpenExMode { omRead, omWrite };
#pragma option pop

#pragma pack(push, 4)
struct TJvPnPInfo
{
	unsigned DeviceID;
	AnsiString DevicePath;
	unsigned Capabilities;
	AnsiString ClassDescr;
	AnsiString ClassGUID;
	AnsiString CompatibleIDs;
	unsigned ConfigFlags;
	AnsiString DeviceDescr;
	AnsiString Driver;
	AnsiString FriendlyName;
	AnsiString HardwareID;
	AnsiString LowerFilters;
	AnsiString Mfg;
	AnsiString UpperFilters;
	AnsiString Address;
	unsigned BusNumber;
	AnsiString BusType;
	AnsiString Characteristics;
	AnsiString DevType;
	AnsiString EnumeratorName;
	unsigned Exclusive;
	AnsiString LegacyBusType;
	AnsiString LocationInfo;
	AnsiString PhysDevObjName;
	AnsiString Security;
	AnsiString Service;
	unsigned UINumber;
	AnsiString UINumberFormat;
} ;
#pragma pack(pop)

typedef DynamicArray<HIDP_LINK_COLLECTION_NODE >  HidControllerClass__2;

class DELPHICLASS TJvHidDeviceController;
class PASCALIMPLEMENTATION TJvHidDeviceController : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	#pragma pack(push, 1)
	GUID FHidGuid;
	#pragma pack(pop)
	
	Classes::TNotifyEvent FDeviceChangeEvent;
	TJvHidEnumerateEvent FEnumerateEvent;
	TJvHidUnplugEvent FDevUnplugEvent;
	bool FDeviceChangeFired;
	Classes::TList* FList;
	int FNumCheckedInDevices;
	int FNumCheckedOutDevices;
	int FNumUnpluggedDevices;
	bool __fastcall CheckThisOut(TJvHidDevice* &HidDev, int Idx, bool Check);
	void __fastcall FillInList(Classes::TList* &List);
	bool __fastcall EventPipe(Messages::TMessage &Msg);
	
protected:
	void __fastcall DoDeviceChange(void);
	bool __fastcall DoEnumerate(TJvHidDevice* HidDev, int Idx);
	void __fastcall SetDeviceChangeEvent(const Classes::TNotifyEvent Notifier);
	void __fastcall SetEnumerate(const TJvHidEnumerateEvent Enumerator);
	void __fastcall SetDevUnplug(const TJvHidUnplugEvent Unplugger);
	
public:
	__property GUID HidGuid = {read=FHidGuid};
	__fastcall virtual TJvHidDeviceController(Classes::TComponent* AOwner);
	__fastcall virtual ~TJvHidDeviceController(void);
	void __fastcall CheckIn(TJvHidDevice* &HidDev);
	bool __fastcall CheckOut(TJvHidDevice* &HidDev);
	bool __fastcall CheckOutByClass(TJvHidDevice* &HidDev, const AnsiString ClassName);
	bool __fastcall CheckOutByID(TJvHidDevice* &HidDev, const int Vid, const int Pid);
	bool __fastcall CheckOutByIndex(TJvHidDevice* &HidDev, const int Idx);
	bool __fastcall CheckOutByProductName(TJvHidDevice* &HidDev, const WideString ProductName);
	bool __fastcall CheckOutByVendorName(TJvHidDevice* &HidDev, const WideString VendorName);
	int __fastcall CountByClass(const AnsiString ClassName);
	int __fastcall CountByID(const int Vid, const int Pid);
	int __fastcall CountByProductName(const WideString ProductName);
	int __fastcall CountByVendorName(const WideString VendorName);
	int __fastcall Enumerate(void);
	/*         class method */ static AnsiString __fastcall HidVersion(TMetaClass* vmt);
	__property int NumCheckedInDevices = {read=FNumCheckedInDevices, nodefault};
	__property int NumCheckedOutDevices = {read=FNumCheckedOutDevices, nodefault};
	__property int NumUnpluggedDevices = {read=FNumUnpluggedDevices, nodefault};
	
__published:
	__property TJvHidEnumerateEvent OnEnumerate = {read=FEnumerateEvent, write=SetEnumerate};
	__property Classes::TNotifyEvent OnDeviceChange = {read=FDeviceChangeEvent, write=SetDeviceChangeEvent};
	__property TJvHidUnplugEvent OnDeviceUnplug = {read=FDevUnplugEvent, write=SetDevUnplug};
	void __fastcall DeviceChange(void);
};


class PASCALIMPLEMENTATION TJvHidDevice : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TJvHidDeviceController* FMyController;
	bool FIsPluggedIn;
	bool FIsCheckedOut;
	bool FIsEnumerated;
	unsigned FHidFileHandle;
	unsigned FHidOverlappedRead;
	unsigned FHidOverlappedWrite;
	_OVERLAPPED FOvlRead;
	_OVERLAPPED FOvlWrite;
	HIDD_ATTRIBUTES FAttributes;
	HIDP_CAPS FCaps;
	TJvPnPInfo FPnPInfo;
	WideString FVendorName;
	WideString FProductName;
	WideString FPhysicalDescriptor;
	WideString FSerialNumber;
	Classes::TStringList* FLanguageStrings;
	void *FPreparsedData;
	int FNumInputBuffers;
	int FNumOverlappedBuffers;
	DynamicArray<HIDP_LINK_COLLECTION_NODE >  FLinkCollection;
	unsigned FMaxDataListLength;
	unsigned FMaxUsageListLength;
	unsigned FMaxButtonListLength;
	unsigned FReportTypeParam;
	Word FUsagePageParam;
	Word FLinkCollectionParam;
	Word FUsageParam;
	TJvHidUnplugEvent FUnplug;
	bool __fastcall IsAccessible(void);
	void __fastcall GetMax(void);
	AnsiString __fastcall GetDeviceStringAnsi(Byte Idx);
	WideString __fastcall GetDeviceStringUnicode(Byte Idx);
	HIDP_LINK_COLLECTION_NODE __fastcall GetLinkCollectionNode(Word Idx);
	HIDD_CONFIGURATION __fastcall GetConfiguration();
	void __fastcall SetConfiguration(const HIDD_CONFIGURATION &Config);
	void __fastcall SetNumInputBuffers(const int Num);
	void __fastcall SetNumOverlappedBuffers(const int Num);
	void __fastcall SetReportTypeParam(const unsigned ReportType);
	void __fastcall SetUsagePageParam(const Word UsagePage);
	__fastcall TJvHidDevice(const TJvPnPInfo &PnPInfo, const TJvHidDeviceController* Controller);
	
protected:
	void __fastcall DoUnplug(void);
	void __fastcall SetUnplug(const TJvHidUnplugEvent Event);
	
public:
	__fastcall TJvHidDevice(void);
	__fastcall virtual ~TJvHidDevice(void);
	__property HIDD_ATTRIBUTES Attributes = {read=FAttributes};
	__property HIDP_CAPS Caps = {read=FCaps};
	__property HIDD_CONFIGURATION Configuration = {read=GetConfiguration, write=SetConfiguration};
	__property void * PreparsedData = {read=FPreparsedData};
	__property AnsiString DeviceStrings[Byte Idx] = {read=GetDeviceStringAnsi};
	__property WideString DeviceStringsUnicode[Byte Idx] = {read=GetDeviceStringUnicode};
	__property HIDP_LINK_COLLECTION_NODE LinkCollectionNodes[Word Idx] = {read=GetLinkCollectionNode};
	bool __fastcall CancelIO(const TJvOpenExMode Mode);
	void __fastcall CloseFile(void);
	void __fastcall CloseFileEx(const TJvOpenExMode Mode);
	bool __fastcall DeviceIoControl(unsigned IoControlCode, void * InBuffer, unsigned InSize, void * OutBuffer, unsigned OutSize, unsigned &BytesReturned);
	bool __fastcall FlushQueue(void);
	int __fastcall GetButtonCaps(Hid::PHIDPButtonCaps ButtonCaps, Word &Count);
	int __fastcall GetButtons(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall GetButtonsEx(Hid::PUsageAndPage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall GetData(Hid::PHIDPData DataList, unsigned &DataLength, void *Report, unsigned ReportLength);
	bool __fastcall GetFeature(void *Report, const int Size);
	int __fastcall GetScaledUsageValue(int &UsageValue, void *Report, unsigned ReportLength);
	int __fastcall GetSpecificButtonCaps(Hid::PHIDPButtonCaps ButtonCaps, Word &Count);
	int __fastcall GetSpecificValueCaps(Hid::PHIDPValueCaps ValueCaps, Word &Count);
	int __fastcall GetUsages(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall GetUsagesEx(Hid::PUsageAndPage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall GetUsageValue(unsigned &UsageValue, void *Report, unsigned ReportLength);
	int __fastcall GetUsageValueArray(char * UsageValue, Word UsageValueByteLength, void *Report, unsigned ReportLength);
	int __fastcall GetValueCaps(Hid::PHIDPValueCaps ValueCaps, Word &Count);
	bool __fastcall OpenFile(void);
	bool __fastcall OpenFileEx(TJvOpenExMode Mode);
	int __fastcall SetButtons(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall SetData(Hid::PHIDPData DataList, unsigned &DataLength, void *Report, unsigned ReportLength);
	bool __fastcall SetFeature(void *Report, const int Size);
	int __fastcall SetScaledUsageValue(int UsageValue, void *Report, unsigned ReportLength);
	int __fastcall SetUsages(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall SetUsageValue(unsigned UsageValue, void *Report, unsigned ReportLength);
	int __fastcall SetUsageValueArray(char * UsageValue, Word UsageValueByteLength, void *Report, unsigned ReportLength);
	int __fastcall UnsetButtons(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	int __fastcall UnsetUsages(Hid::PUsage UsageList, unsigned &UsageLength, void *Report, unsigned ReportLength);
	bool __fastcall ReadFile(void *Report, unsigned ToRead, unsigned &BytesRead);
	bool __fastcall ReadFileEx(void *Report, unsigned ToRead, void * CallBack);
	bool __fastcall WriteFile(void *Report, unsigned ToWrite, unsigned &BytesWritten);
	bool __fastcall WriteFileEx(void *Report, unsigned ToWrite, void * CallBack);
	__property unsigned HidFileHandle = {read=FHidFileHandle, nodefault};
	__property unsigned HidOverlappedRead = {read=FHidOverlappedRead, nodefault};
	__property unsigned HidOverlappedWrite = {read=FHidOverlappedWrite, nodefault};
	__property bool IsCheckedOut = {read=FIsCheckedOut, nodefault};
	__property bool IsPluggedIn = {read=FIsPluggedIn, nodefault};
	__property Classes::TStringList* LanguageStrings = {read=FLanguageStrings};
	__property unsigned MaxButtonListLength = {read=FMaxButtonListLength, nodefault};
	__property unsigned MaxDataListLength = {read=FMaxDataListLength, nodefault};
	__property unsigned MaxUsageListLength = {read=FMaxUsageListLength, nodefault};
	__property WideString PhysicalDescriptor = {read=FPhysicalDescriptor};
	__property TJvPnPInfo PnPInfo = {read=FPnPInfo};
	__property WideString ProductName = {read=FProductName};
	__property WideString SerialNumber = {read=FSerialNumber};
	__property WideString VendorName = {read=FVendorName};
	
__published:
	__property Word LinkCollectionParam = {read=FLinkCollectionParam, write=FLinkCollectionParam, nodefault};
	__property int NumInputBuffers = {read=FNumInputBuffers, write=SetNumInputBuffers, nodefault};
	__property int NumOverlappedBuffers = {read=FNumOverlappedBuffers, write=SetNumOverlappedBuffers, nodefault};
	__property unsigned ReportTypeParam = {read=FReportTypeParam, write=SetReportTypeParam, nodefault};
	__property Word UsagePageParam = {read=FUsagePageParam, write=SetUsagePageParam, nodefault};
	__property Word UsageParam = {read=FUsageParam, write=FUsageParam, nodefault};
	__property TJvHidUnplugEvent OnUnplug = {read=FUnplug, write=SetUnplug};
};


//-- var, const, procedure ---------------------------------------------------
#define cHidKeyboardClass "Keyboard"
#define cHidMouseClass "Mouse"
#define cHidNoClass "HIDClass"
extern PACKAGE int __fastcall HidCheck(const int RetVal)/* overload */;
extern PACKAGE BOOL __fastcall HidCheck(const BOOL RetVal)/* overload */;
extern PACKAGE int __fastcall HidError(const int RetVal);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Hidcontrollerclass */
using namespace Hidcontrollerclass;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// HidControllerClass
